/*
 * DataWriter.java
 *
 * Created on July 12, 2007, 6:56 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.pythsoft;

import javax.microedition.io.file.FileConnection;
import java.util.Date;
import java.util.Calendar;
import java.io.IOException;
import com.mindprod.ledatastream.LEDataOutputStream;
import javax.microedition.io.Connector;
import javax.microedition.midlet.*;

/**
 *
 * @author Administrator
 */
public class DataWriter {
    
    FileConnection conn = null;
    LEDataOutputStream fos = null;
    MIDlet md;
    /** Creates a new instance of DataWriter */
    public DataWriter(MIDlet amd) {
        md = amd;
    }
    
    private boolean openFile(String filename) throws IOException {
        String v = System.getProperty("microedition.io.file.FileConnection.version" );
        
        if( v != null ){
            // FCOP available
            
            // System.out.println("FCOP available");
        } else {
            // FCOP not available
            System.out.println("FCOP not available");
        }
/*        Enumeration roots = FileSystemRegistry.listRoots();
        
        while (roots.hasMoreElements()) {
            String nextElement = (String) roots.nextElement();
            System.out.println("Root: " + nextElement);
        }*/
        Settings sc = null;
        try {
            sc = Settings.getInstance(md);
        } catch (javax.microedition.rms.RecordStoreException e) {
        }
        String storeFolder = sc.getStringProperty("storeFolder","e:/");
        String url = "file:///" + storeFolder + filename;
        conn = (FileConnection) Connector.open( url);
        if (!conn.exists())
            conn.create();
        fos = new LEDataOutputStream(conn.openOutputStream());
        return true;
    }
    
    private boolean writeHeader(WBTController GPSDevice) throws IOException {
        char[] header = new char[1024];
        byte[] nulls = new byte[1024];
        String DateString = dateToString() + "_" + timeToString();
        String TK1Magic = new String("WintecLogFormat");
        String GPSName = GPSDevice.GpsInfo();
        float HWVersion = GPSDevice.getHwVersion().floatValue();
        float SWVersion = GPSDevice.getSwVersion().floatValue();
        String serialNumber = GPSDevice.getSerialNumber();
        int DataEndInt = GPSDevice.getBytesToRead() + 1024;

        System.out.println("Magic added, SWVersion: " + Float.toString(SWVersion) + "DataEndInt : " + DataEndInt);
        fos.write(TK1Magic.getBytes());
        fos.write(nulls, 0, 1);
        fos.writeFloat(HWVersion);
        fos.writeFloat(SWVersion);
        fos.writeFloat(1f); // Unknown value, log format version?
        fos.writeInt(0x0010BF41); // Unknown value
        fos.writeInt(GPSDevice.getPointCount()+1); // Number of points
        //fos.writeInt(0); // Don't know number of points yet...
        fos.writeFloat(0); // Known NULL
        
        //fos.write(nulls, 0, 16);
        fos.write(GPSName.getBytes());
        fos.write(nulls, 0, 40 - GPSName.length());
        fos.write(serialNumber.getBytes());
        fos.write(nulls, 0, 40 - serialNumber.length());
        
        fos.write(DateString.getBytes());
        fos.write(nulls, 0, 1);
        fos.writeInt(DataEndInt+16);
        fos.write(nulls, 0, 1024-144);
        System.out.println("Header written");
        return true;
    };
    
    public boolean fixHeader(int trackCount) throws IOException {
        fos.flush();
        fos.close();
        LEDataOutputStream tmpStream = new LEDataOutputStream(conn.openOutputStream(0x0090));
        tmpStream.write(trackCount);
        tmpStream.close();
        return true;
    }
    
    public boolean closeFile() throws IOException {
        conn.close();
        return true;        
    }
    
    public LEDataOutputStream prepareFile(String filename, WBTController GPSDevice) throws IOException {
        this.openFile(filename);
        this.writeHeader(GPSDevice);        
        return fos;
    }
    
    public boolean writeData(String filename, WBTController GPSDevice) throws IOException {
        
        String test = new String(GPSDevice.getData());
        this.openFile(filename);
        this.writeHeader(GPSDevice);
        
        fos.write(test.getBytes());
        fos.write(test.substring(test.length()-15).getBytes());
        fos.writeInt(67108864);
        
        this.closeFile();
        return true;
    }
    
    /**
     * Create a string from the TimeOfDay portion of a time/date as
     * hh::mm::ss
     * @param data The date/time as milliseconds since the epoch.
     */
    public static String timeToString() {
        Calendar c = Calendar.getInstance();
        c.setTime(new Date());
        int h = c.get(Calendar.HOUR_OF_DAY);
        int m = c.get(Calendar.MINUTE);
        int s = c.get(Calendar.SECOND);
        String t = (h<10? "0": "")+h+":"+(m<10? "0": "")+m+":"+(s<10?
            "0": "")+s;
        return t;
    }
    
    /**
     * Create a string from the date portion of a time/date as yyyy-mm-dd
     * @param date the dat/time as milliseconds since the epoch
     */
    public static String dateToString() {
        Calendar c = Calendar.getInstance();
        c.setTime(new Date());
        int y = c.get(Calendar.YEAR);
        int m = c.get(Calendar.MONTH) + 1;
        int d = c.get(Calendar.DATE);
        String t = (y<10? "0": "")+y+"_"+(m<10? "0": "")+m+"_"+(d<10?
            "0": "")+d;
        return t;
    }
}
